using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {

            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dead Game Protogen Player v1",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dead game protogen player v1 frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dead game protogen player.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head1.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail1.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dead Game Protogen Player v2",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dead game protogen player v2 frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dead game protogen player.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light2.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head1.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail1.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dead Game Protogen Player v3",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dead game protogen player v3 frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dead game protogen player.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light3.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head1.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail1.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dead Game Protogen Guard Circle",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dead game protogen guard circle frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dead game protogen guard.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light4.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head2.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail2.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dead Game Protogen Guard Triangle",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dead game protogen guard triangle frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dead game protogen guard.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light5.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head2.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail2.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dead Game Protogen Guard Square",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dead game protogen guard square frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dead game protogen guard.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light6.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head2.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail2.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dead Game Protogen Leader",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dead game protogen leader frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dead game protogen leader.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light7.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head3.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail3.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dead Game Protogen Vip v1",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dead game protogen vip v1 frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dead game protogen vip.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light1.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head4.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail4.png"); 	
                  }
              }
            );
            Liquid.Register("BLAU", new Purp());

            ModAPI.Register(
              new Modification()
              {
                  OriginalItem = ModAPI.FindSpawnable("Human"),
                  NameOverride = "Dead Game Protogen Vip v2",
                  NameToOrderByOverride = "A",
                  DescriptionOverride = "Weak robot furry",
                  CategoryOverride = ModAPI.FindCategory("Entities"),
                  ThumbnailOverride = ModAPI.LoadSprite("dead game protogen vip v2 frame.png"),
                  AfterSpawn = (Instance) =>
                  {
                      var person = Instance.GetComponent<PersonBehaviour>();
                      var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                      person.SetBodyTextures(ModAPI.LoadTexture("dead game protogen vip.png"), ModAPI.LoadTexture("protogen flesh.png"), ModAPI.LoadTexture("protogen bone.png"), 1);
                      person.SetBruiseColor(56, 141, 224);
                      person.SetSecondBruiseColor(56, 119, 224);
                      person.SetThirdBruiseColor(70, 97, 226);
                      person.SetRottenColour(202, 199, 104);
                      person.SetBloodColour(68, 170, 242);
                      var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                      var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();

                      foreach (LimbBehaviour limb in person.Limbs)
                      {
                          cal.Sprites = limb.BloodDecal.Sprites;
                          cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                          cal.Color = Color.cyan;
                          limb.BloodDecal = cal; //Lazy
                         limb.BloodLiquidType = "BLAU";
                          limb.CirculationBehaviour.ClearLiquid();
                          limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("BLAU"), 1f);
                          limb.PhysicalBehaviour.Properties = prop;
                      }
                      var Safe = new GameObject();
                      person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                      person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                      prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                      Safe.SetActive(false);
                      cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                      cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                      cal2.Color = Color.cyan;
                      person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                     foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                          main.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }

                      foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                      {
                          var moon = thi.main;
                          moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(29, 185, 255, 0));
                          if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                          {
                              prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                          }
                      }
                             Transform child = Instance.transform.GetChild(5);
                             GameObject gameObject1 = new GameObject("Headlamp");
                             gameObject1.transform.SetParent(child);
                             gameObject1.transform.localPosition = new Vector3(0f, 0f);
                             gameObject1.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                             gameObject1.transform.localScale = new Vector3(0.25f, 0.25f);
                             SpriteRenderer spriteRenderer1 = gameObject1.AddComponent<SpriteRenderer>();
                             spriteRenderer1.sprite = ModAPI.LoadSprite("light3.png", 1f, true);
                             spriteRenderer1.gameObject.AddComponent<GlowingEyeBehaviour>();
                             spriteRenderer1.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                             spriteRenderer1.sortingLayerName = "Top";        

					var head = Instance.transform.GetChild(5);
                        var childObject = new GameObject("Head");
                        childObject.transform.SetParent(head);
                        childObject.transform.localPosition = new Vector3(0f, 0f);
                        childObject.transform.rotation = Quaternion.Euler(0f, 0f, 0f);
                        childObject.transform.localScale = new Vector3(0.25f, 0.25f);
                        var childSprite = childObject.AddComponent<SpriteRenderer>();
                        childSprite.sprite = ModAPI.LoadSprite("head4.png");
                        childSprite.sortingLayerName = "Top";    

            var kev = new GameObject("Tail");
                        kev.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                        kev.transform.localPosition = new Vector3(0, 0f);
                        kev.transform.localScale = new Vector3(0.25f, 0.25f);
                        var kevSprite = kev.AddComponent<SpriteRenderer>();
                        kevSprite.sprite = ModAPI.LoadSprite("tail4.png"); 	
                  }
              }
            );

        }
    }
}

public class Purp : Liquid
{
    public Purp()
    {
        this.Color = new Color32(51, 153, 255, 0);
    }

    public override void OnEnterContainer(BloodContainer container)
    {
    }

    public override void OnEnterLimb(LimbBehaviour limb)
    {
        if (limb.SpeciesIdentity == "Human" && UnityEngine.Random.value > 0.995f)
        {
            limb.PhysicalBehaviour.Charge += 0.1f;
        }
    }

    public override void OnExitContainer(BloodContainer container)
    {
    }
                                         public const string ID = "BLAU";
                                 }
    

